load('sweep_toepmat2_07-02_1021.mat')
%%

mslice = 1;
nslice = 1;
powslice = 1;
% expanderconst = 0.99;
% colormap gray

psize = [380,320];
% emax = max(mle0(:));
% emin = min(mle0(:));
xlims = [min(k),max(k)];
ylims = [min(p(p>0)),max(p(p>0))];
ax = nan(3,1);
for i = (1:3)
	fh = figure(i); clf
	set(i,'Position',[100+i*psize(1),100,psize]);
	ax(i) = axes('Parent',i);
end
% ax = arrayfun(@(z) subplot(2,3,z),1:5);

kpline = 2./xlims;
pslice = p>0;

ncontour = 10;
mlemax = 0.28;
msrmax = 0.15;
fdrmax = 0.25;

axes(ax(1))
% mlerr = permute(mean(L1Err,6),[4,1,2,3,5]);
mle0 = permute(mean(L1Err(:,mslice,nslice,:,powslice,:),6),[4,1,2,3]);
mle1 = bsxfun(@rdivide,mle0(pslice,:,mslice,nslice,powslice),k);
pinned = max(mle1(:))>mlemax;
if pinned; mle1 = min(mle1,mlemax); end
contourf(k,p(pslice),mle1,linspace(min(mle1(:)),max(mle1(:)),ncontour))
% surf(k,p(pslice),zeros(size(mle1)),min(mle1,mlemax)), view([0,90]), shading interp
caxis(min(caxis,mlemax))
hold on
plot(xlims,kpline,'r--','LineWidth',1.2)
hold off
% caxis([emin,emax]),colorbar
cb = colorbar; % set(cb,'TickLabels',cellfun(@(s) sprintf('10^{%s}',s),get(cb,'TickLabels'),'Uni',false)); % convert colorbar labels to powers
if pinned; cbtick = get(cb,'TickLabels'); cbtick{end} = [cbtick{end},'+']; set(cb,'TickLabels',cbtick); end
xlabel('k'),ylabel('p'),title('l1 Error','FontWeight','normal')

axes(ax(2))
msr1 = permute(1-mean(TDR(:,mslice,nslice,pslice,powslice,:),6),[4,1,2,3]);
pinned = max(msr1(:))>msrmax;
if pinned; msr1 = min(msr1,mlemax); end
contourf(k,p(pslice),msr1,linspace(0,max(msr1(:)),ncontour))
% surf(k,p(pslice),zeros(size(msr1)),msr1), view([0,90]), shading interp
cax = caxis; caxis([0,min(cax(2),msrmax)])
hold on
plot(xlims,kpline,'r--','LineWidth',1.2)
hold off
% caxis([0,1])
cb = colorbar;
if pinned; cbtick = get(cb,'TickLabels'); cbtick{end} = [cbtick{end},'+']; set(cb,'TickLabels',cbtick); end
xlabel('k'),ylabel('p'),title('Miss Rate','FontWeight','normal')

axes(ax(3))
fdr1 = permute(mean(FDR(:,mslice,nslice,pslice,powslice,:),6),[4,1,2,3]);
pinned = max(fdr1(:))>fdrmax;
if pinned; fdr1 = min(fdr1,fdrmax); end
contourf(k,p(pslice),min(fdr1,fdrmax),linspace(0,max(fdr1(:)),ncontour))
% surf(k,p(pslice),zeros(size(fdr1)),min(fdr1,fdrmax)),view([0,90]), shading interp
cax = caxis; caxis([0,min(cax(2),fdrmax)])
hold on
plot(xlims,kpline,'r--','LineWidth',1.2)
hold off
% caxis([0,1])
cb = colorbar;
if pinned; cbtick = get(cb,'TickLabels'); cbtick{end} = [cbtick{end},'+']; set(cb,'TickLabels',cbtick); end
xlabel('k'),ylabel('p'),title('False Discovery Rate','FontWeight','normal')



set(ax,'XScale','log','YScale','log','XLim',xlims,'YLim',ylims,'XGrid','on','XMinorGrid','off','YGrid','on','YMinorGrid','off','layer','top','DataAspectRatio',[diff(log10(ylims))/diff(log10(xlims)),diff(ylims)/diff(xlims),1])
% set(fh,'Units','centimeters'); fpos = get(fh(1),'position'); set(fh,'PaperPositionMode','Auto','PaperUnits','centimeters','PaperSize',[fpos(3), fpos(4)]);
set(ax,'FontName','Myriad Pro')
%{
p0slice = find(p==0,1,'first');
pslice = 2:8:numel(p);
% pslice = 2:2:10;
if any(p0slice)
	figure(4),clf
	hh = loglog(k,mle0(p0slice,:),k,mle0(pslice,:));
	set(hh(1),'LineStyle','--')
	leg = [{'traditional'},arrayfun(@(z) sprintf('np=%g',z),n(nslice)*p(pslice),'Uni',false)];
	legend(hh,leg)
	xlabel('k')
end

p0slice = p==0;
kslice = 1:3:numel(k);
% pslice = 2:2:10;
if any(p0slice)
	figure(4),clf
	pval = p(~p0slice);
	hh = loglog([min(pval),max(pval)],[1;1]*mle0(p0slice,kslice),pval,mle0(~p0slice,kslice));
% 	set(hh(p0slice),'LineStyle','--')
% 	leg = [{'traditional'},arrayfun(@(z) sprintf('np=%g',z),n(nslice)*p(pslice),'Uni',false)];
% 	legend(hh,leg)
	xlabel('p')
end
%}