% toepmat_sweep2
clear

k = round(10.^(0.5:1/6:3));
m = 50e3;
n = 5e3;
% p = [logspace(-4,-0.5,15),0.45:0.15:0.75];
% p = [logspace(-3,-1/3,9),0.75];
p = [0,10.^(-3:1/8:-0.5)];
% p = logspace(-1,-0.25,4);
noisepow = 0.05;
ntrial = 500;

% k = k(1:2:end);
% p = p(1:3:end);
% ntrial = 15;

simsize = [numel(k),numel(m),numel(n),numel(p),numel(noisepow),ntrial];

TDR = nan(simsize);
FDR = nan(simsize);
L1Err = nan(simsize);
L05Err = nan(simsize);
TopKfrac = nan(simsize);
exectime = nan(simsize);

vardims = {'k';'m';'n';'p';'noisepow'};
varnames = {'TDR',@(z) nanmean(z.TDR,6);
	'FDR',@(z) nanmean(z.FDR,6);
	'L_1 Error',@(z) nanmean(z.L1Err,6);
	'L_{0.5} Error',@(z) nanmean(z.L05Err,6)};

fprintf('Running %i trials\n',prod(simsize));

%%

t0 = tic;
parfor i = 1:prod(simsize)
	[ik,im,in,ip,inoise,it] = ind2sub(simsize,i);
% 	npulse = ceil(m(im)*p(ip));
% 	npulse = sum(rand(m(im),1)<p(ip)); % binomial random var
% 	npulse = binornd(m(im)-n(in)+1,p(ip)); % binomial random var
	t1 = tic;
	z = toeptrial2(k(ik),m(im),n(in),p(ip),noisepow(inoise));
	exectime(i) = toc(t1);
	td = z.rec_abundance(z.true_abundance>0)>0;
	fd = z.true_abundance(z.rec_abundance>0)<=0;
	if isempty(td)
		TDR(i) = 0;
	else
		TDR(i) = mean(td);
	end
	if isempty(fd)
		FDR(i) = 0;
	else
		FDR(i) = mean(fd);
	end
% 	TDR(i) = mean(z.rec_abundance(z.true_abundance>0)>0);
% 	FDR(i) = mean(z.true_abundance(z.rec_abundance>0)<=0);
	L1Err(i) = sum(abs(z.true_abundance-z.rec_abundance));
	L05Err(i) = sum(abs(z.true_abundance-z.rec_abundance).^0.5).^2;
	[~,topki] = sort(z.rec_abundance,'descend');
	TopKfrac(i) = nnz(z.true_abundance(topki(1:k(ik))))/k(ik);
end
t0 = toc(t0);
fprintf('Done in %is (%ih%im)\n',ceil(t0),floor(t0/3600),ceil(mod(t0,3600)/60));

%%
% save(['sweep_toepmat2_' datestr(now,'mm-dd_HHMM')],'-v7.3')